"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = __importDefault(require("path"));
const yargs_1 = __importDefault(require("yargs"));
const fs_1 = __importDefault(require("fs"));
const helpers_1 = require("yargs/helpers");
const hogan = __importStar(require("hogan.js"));
const defaultTemplate_1 = __importDefault(require("./defaultTemplate"));
const argv = (0, yargs_1.default)((0, helpers_1.hideBin)(process.argv)).argv;
const pkgPath = path_1.default.resolve(process.cwd(), 'package.json');
let pkg;
try {
    pkg = JSON.parse(fs_1.default.readFileSync(pkgPath).toString());
}
catch (e) {
    throw new Error(`Unable to parse ${pkgPath}: ${e.message}`);
}
Object.keys(pkg).forEach(k => {
    if ('dependencies' === k) {
        pkg.dependencies = Object.keys(pkg.dependencies).map((key) => {
            const depPkgPath = path_1.default.resolve(process.cwd(), 'node_modules', key, 'package.json');
            return JSON.parse(fs_1.default.readFileSync(depPkgPath).toString());
        });
    }
    if ('devDependencies' === k) {
        pkg.devDependencies = Object.keys(pkg.devDependencies).map((key) => {
            const depPkgPath = path_1.default.resolve(process.cwd(), 'node_modules', key, 'package.json');
            return JSON.parse(fs_1.default.readFileSync(depPkgPath).toString());
        });
    }
});
const template = argv['template'] || defaultTemplate_1.default;
const out = hogan.compile(template).render(pkg);
fs_1.default.writeFileSync(path_1.default.resolve(process.cwd(), 'README.md'), out);
